/*---------------------------------
 * Block copy up to n characters.
 *--------------------------------*/

/* because of some bugs in LC this routine is hard coded for 4-byte longs */

#define SZLNG 4

char *memcpy(to, from, n)
char *to;
char *from;
unsigned n;
{
   unsigned i;

   /* see if we should do long-to-long copy */
   if ( n >= 32  &&
         (i = ((int)from & 3)) == ((int)to & 3) )
   {
      register long *lp1;
      register long *lp2;
      register unsigned u;
      char *cp1;
      char *cp2;

      /* copy by byte until long aligned */
      i = n - (u = SZLNG - i);
      if (u != 0)
         for (cp1 = from, cp2 = to; u--; )
            *cp2++ = *cp1++;

      /* copy by long */
      u = i >> 2;        /* i / SZLNG */
      for (lp1 = (long *)cp1, lp2 = (long *)cp2; u--; )  /* FAST copy */
         *lp2++ = *lp1++;

      /* copy by byte */
      if ((u = (i & 3)) != 0)    /* (i % SZLNG) */
         for (cp1 = (char *)lp1, cp2 = (char *)lp2; u--; )
            *cp2++ = *cp1++;
   }
   else  /* normal method */
   {
      register char *cp1;
      register char *cp2;
      register unsigned u;

      for (cp1 = from, cp2 = to, u = n; u--;  )
         *cp2++ = *cp1++;
   }
   return (to);
}
